----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    06:29:07 01/06/2009 
-- Design Name: 
-- Module Name:    RAM_mgr - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity OLED_RAM_mgr is
	 Generic( ADDL : std_logic_vector(8 downto 0);
				 ADDH : std_logic_vector(8 downto 0);
				 DATL : std_logic_vector(8 downto 0);
				 DATH : std_logic_vector(8 downto 0));
    Port ( clk       : in  STD_LOGIC;
           reset     : in  STD_LOGIC;
           pic_w     : in  STD_LOGIC;
           addr      : in  STD_LOGIC_VECTOR (8 downto 0);
           pic_out   : in  STD_LOGIC_VECTOR (7 downto 0);
           pic_in    : out STD_LOGIC_VECTOR (7 downto 0);
           ram_addr  : out  STD_LOGIC_VECTOR (10 downto 0);
           ram_din   : in   STD_LOGIC_VECTOR (15 downto 0);
           ram_dout  : out  STD_LOGIC_VECTOR (15 downto 0);
           ram_write : out  STD_LOGIC);
end OLED_RAM_mgr;

architecture Behavioral of OLED_RAM_mgr is

signal addr_int    : std_logic_vector(10 downto 0);

begin

ram_addr     <= addr_int;

process(addr, addr_int, ram_din)
begin
	if addr=ADDL then
		pic_in <= addr_int(7 downto 0);
	elsif addr=ADDH then
		pic_in <= "00000" & addr_int(10 downto 8);
	elsif addr=DATL then
		pic_in <= ram_din(7 downto 0);
	elsif addr=DATH then
		pic_in <= ram_din(15 downto 8);
	else
		pic_in <= "00000000";
	end if;
end process;

process(clk)
begin
if clk'event and clk='1' then
  if reset='1' then
    addr_int  <= "00000000000";
    ram_write <= '0';
  else
	 if pic_w='1' and addr=DATL then
		ram_write <= '1';
      ram_dout  <= ram_din(15 downto 8) & pic_out;
	 elsif pic_w='1' and addr=DATH then
		ram_write <= '1';
      ram_dout  <= pic_out & ram_din(7 downto 0);
	 else
      ram_write <= '0';
      if pic_w='1' and addr=ADDL then
		  addr_int(7 downto 0) <= pic_out;
	   elsif pic_w='1' and addr=ADDH then
		  addr_int(10 downto 8) <= pic_out(2 downto 0);
	   end if;
	 end if;
  end if;
end if;
end process;

end Behavioral;

